Ensure a smooth upgrade path after adv svc split

Bug #1401895 reported by Numan Siddique on 2014-12-12
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
grenade
Undecided
Armando Migliaccio
neutron
Critical
Jakub Libosvar

Bug Description

check-grenade-dsvm-neutron is failing after the services split. An example of a traceback is [1].

This is because no thin shims have been provided for the drivers, as done for plugins in [2]. Thin shims should be temporary just to provide a bw compat upgrade path, but they should be replaced by a more effective mechanism like 1) make load_drivers() use stevedore, and 2) add entry points for bw compatibility.

[1] http://logs.openstack.org/51/140851/19/check/check-grenade-dsvm-neutron/da95f11/logs/new/screen-q-svc.txt.gz?level=TRACE
[2] https://review.openstack.org/#/c/140515/

affects: neutron → openstack-ci
summary: - check-grenade-dsvm-neutron is failing since today
+ check-grenade-dsvm-neutron is failing mostly because of neutron services
+ split
Changed in openstack-ci:
assignee: nobody → Ihar Hrachyshka (ihar-hrachyshka)
James E. Blair (corvus) on 2014-12-12
no longer affects: openstack-ci

I am removing openstack-ci from this bug for two reasons. First this is an issue with neutron and grenade. They will need to sort out an upgrade path for these services. Second OpenStack infra bugs are now filed at: https://storyboard.openstack.org/#!/project_group/55

Changed in neutron:
assignee: nobody → Armando Migliaccio (armando-migliaccio)
Changed in grenade:
status: New → Confirmed
summary: - check-grenade-dsvm-neutron is failing mostly because of neutron services
- split
+ check-grenade-dsvm-neutron fails after svc split

@Ihar: when did I volunteer for the Neutron fix? :P

Changed in neutron:
status: New → Confirmed
summary: - check-grenade-dsvm-neutron fails after svc split
+ Ensure a smooth upgrade path after adv svc split
Changed in grenade:
assignee: nobody → Armando Migliaccio (armando-migliaccio)
description: updated

Nah, sorry, that was a miscommunication prolly. ;)
I'm moving the bug back to my plate then. :)

Changed in neutron:
assignee: Armando Migliaccio (armando-migliaccio) → Ihar Hrachyshka (ihar-hrachyshka)
Kyle Mestery (mestery) on 2014-12-16
Changed in neutron:
importance: Undecided → Critical
milestone: none → kilo-1
assignee: Ihar Hrachyshka (ihar-hrachyshka) → Jakub Libosvar (libosvar)

Fix proposed to branch: master
Review: https://review.openstack.org/142150

Changed in neutron:
status: Confirmed → In Progress

No worries :)

That said, once the Neutron change lands, I would imagine that the follow-up Grenade patch would be to drop the upgrade script, correct?

Changed in neutron:
assignee: Jakub Libosvar (libosvar) → Ihar Hrachyshka (ihar-hrachyshka)
Changed in neutron:
assignee: Ihar Hrachyshka (ihar-hrachyshka) → Jakub Libosvar (libosvar)
Changed in neutron:
assignee: Jakub Libosvar (libosvar) → Ihar Hrachyshka (ihar-hrachyshka)
Kyle Mestery (mestery) wrote :

Moving to Kilo-2 since we have to cut Kilo-1 today.

Changed in neutron:
milestone: kilo-1 → kilo-2
Changed in neutron:
assignee: Ihar Hrachyshka (ihar-hrachyshka) → Armando Migliaccio (armando-migliaccio)
Changed in neutron:
assignee: Armando Migliaccio (armando-migliaccio) → Jakub Libosvar (libosvar)

Fix proposed to branch: master
Review: https://review.openstack.org/142852

Changed in grenade:
status: Confirmed → In Progress

Reviewed: https://review.openstack.org/142150
Committed: https://git.openstack.org/cgit/openstack/neutron/commit/?id=21842feeae0c1a0a59242d28d74765f5cc761c8c
Submitter: Jenkins
Branch: master

commit 21842feeae0c1a0a59242d28d74765f5cc761c8c
Author: Jakub Libosvar <email address hidden>
Date: Tue Dec 16 17:33:23 2014 +0100

    Backward compatibility for advanced services

    Patch implements translation from class paths to neutron to class paths
    to neutron_<adv_service>. It's achieved by defining entry point in
    setup.cfg which is translated by stevedore.

    There will be needed patches in advanced services tree calling
    get_provider_driver_class() function before importing class.

    This patch specifically fixes loading service plugins and
    drivers for service plugin. Patches for agents are still needed in
    neutron repo and adv services repos.

    Alternative and better solution would be implementing new DriverType
    to oslo.config, which will have callback to
    get_provider_driver_class()-like function.

    Co-Authored-By: Ihar Hrachyshka <email address hidden>
    Change-Id: I76af175c4387326a4e5ff95c2f15d8b866dedab3
    Partial-Bug: 1401895

Reviewed: https://review.openstack.org/142474
Committed: https://git.openstack.org/cgit/openstack/neutron-fwaas/commit/?id=8d1c1c4a32c95396e6b8f5f32f229b74fbb105e1
Submitter: Jenkins
Branch: master

commit 8d1c1c4a32c95396e6b8f5f32f229b74fbb105e1
Author: Jakub Libosvar <email address hidden>
Date: Wed Dec 17 16:56:36 2014 +0100

    Backward compatibility for fwaas

    Fwaas driver class is changed to one from this repo in case it attempts
    to be loaded from neutron repo.

    This change depends on I76af175c4387326a4e5ff95c2f15d8b866dedab3

    Change-Id: If850adb3ec9db0a9ff0d43cd7445264c168d241c
    Closes-Bug: 1401895

Changed in neutron:
status: In Progress → Fix Committed

Reviewed: https://review.openstack.org/142482
Committed: https://git.openstack.org/cgit/openstack/neutron-lbaas/commit/?id=52d54dd7d063689f7eae73a98c8c542a6901decd
Submitter: Jenkins
Branch: master

commit 52d54dd7d063689f7eae73a98c8c542a6901decd
Author: Jakub Libosvar <email address hidden>
Date: Wed Dec 17 17:15:55 2014 +0100

    Backward compatibility for lbaas

    Lbaas driver class is changed to one from this repo in case it attempts
    to be loaded from neutron repo.

    This change depends on I76af175c4387326a4e5ff95c2f15d8b866dedab3

    Change-Id: If850adb3ec9db0a9ff0d43cd7445264c168d241c
    Closes-Bug: 1401895

Change abandoned by Jakub Libosvar (<email address hidden>) on branch: master
Review: https://review.openstack.org/142484
Reason: This patch is not needed anymore after agent refactor: https://review.openstack.org/#/c/140918

Reviewed: https://review.openstack.org/142484
Committed: https://git.openstack.org/cgit/openstack/neutron-vpnaas/commit/?id=30fe57e4a883bc64b42f858dbf02d3d79ee84018
Submitter: Jenkins
Branch: master

commit 30fe57e4a883bc64b42f858dbf02d3d79ee84018
Author: Jakub Libosvar <email address hidden>
Date: Wed Dec 17 17:23:47 2014 +0100

    Backward compatibility for vpnaas

    Vpnaas driver class is changed to one from this repo in case it attempts
    to be loaded from neutron repo.

    This change depends on I76af175c4387326a4e5ff95c2f15d8b866dedab3

    Change-Id: I2986a9724396920071a3a22121e5b5a5a08ed059
    Closes-Bug: 1401895

Reviewed: https://review.openstack.org/142852
Committed: https://git.openstack.org/cgit/openstack-dev/grenade/commit/?id=ad79234af5744e4bd586de6f1ffd9fd829f9a619
Submitter: Jenkins
Branch: master

commit ad79234af5744e4bd586de6f1ffd9fd829f9a619
Author: armando-migliaccio <email address hidden>
Date: Thu Dec 18 09:36:36 2014 -0800

    Drop Kilo upgrade hack for Neutron

    This patch removes the need for a special upgrade procedure
    as outlined in [1]. The Neutron codebases have been tweaked
    [2,3,4,5] to allow for a backward compatible upgrade.

    [1] https://wiki.openstack.org/wiki/ReleaseNotes/Kilo#Upgrade_Notes_6
    [2] https://review.openstack.org/#/c/142484/
    [3] https://review.openstack.org/#/c/142482/
    [4] https://review.openstack.org/#/c/142474/
    [5] https://review.openstack.org/#/c/142150/

    Closes-bug: #1401895

    Change-Id: I82b8aa4215f9669bb622548f27f8bb53544c9792

Changed in grenade:
status: In Progress → Fix Committed
Thierry Carrez (ttx) on 2015-02-05
Changed in neutron:
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2015-04-30
Changed in neutron:
milestone: kilo-2 → 2015.1.0
Changed in grenade:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers